/*********************************************************************
 *
 * File:         apptest.c
 *
 * Description:  Test application for NPAC Conferencing System  
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         10-23-96
 *
 *********************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <bstring.h>

#include <netdb.h>
#include <unistd.h>

#include <signal.h>

#include "../lib/common.h"

int sockfd;
Participant part;
int state;
ncsApplication *app;

      
void Quit()
{
  ncsAppDettach(app);
  exit(0);
}


void DisplayMenu()
{
  printf("MENU\n\n");
  printf("1 - Send message\n");
  printf("2 - Quit\n");
}

int ProcessInput(char *buf, int mystate)
{
  char str[100];

  switch(buf[0])
    {
    case '1':
      scanf("%s", str);
      ncsAppSendData(app, 1, str, strlen(str));
      break;

    case '2':
      Quit();
      break;

    default:
      printf("Unknown command\n");
    }

  DisplayMenu();
  return 1;
}
      

void ProcessData(char *data, int len)
{
  ncsData *ncsdata;

  ncsdata = (ncsData *)data;
  switch(ncsdata->type)
    {
    case 1:
      printf("Test application got data: %s\n", ncsdata->data);
      break;

    default:
      printf("Unknown data tag\n");
    }
}

main(int argc, char *argv[])
{
  char buf[100];
  struct timeval timeout;
  fd_set set;
  char *data;
  int size;

  app = ncsAppAttach(5003);

  DisplayMenu();

  timeout.tv_sec = 1;
  timeout.tv_usec = 0;
  while(1)
    {
      sockfd = ncsAppGetFD(app, &set);
      FD_SET(0, &set);
      if(select(sockfd+1, &set, 0, 0, &timeout) > 0)
	if(FD_ISSET(0, &set))
	  {
	    if(fgets(buf, 100, stdin) != NULL)
	      ProcessInput(buf, state);
	  }
      ncsAppProcessIncoming(app, &set);
      size = ncsAppGetData(app, &set, &data);
      if(size > 0)
	ProcessData(data, size);
    }
}


