#include <stdlib.h>
#include <stdio.h>
#include <Xm/Xm.h>

#include "Object_procs.h"

GObject *head = NULL;

GObject *obj_add(int type, int x1, int y1, int x2, int y2, const char *text,
		 const char *color, int width)
  {   
     GObject *pom;

     pom = head;
     if (head == NULL)
       {
	  head = malloc(sizeof(GObject));
	  pom = head;
       }
     else
       {
	  while(pom->next != NULL)
	     pom = pom->next;
	  pom->next = malloc(sizeof(GObject));
	  pom = pom->next;
       }
     
     pom->type = type;
     pom->x1 = x1;
     pom->y1 = y1;
     pom->x2 = x2;
     pom->y2 = y2;
     strcpy(pom->text, text);

     strcpy(pom->color, color);
     pom->width = width;

     pom->next = NULL;

     return pom;
  }

GObject *obj_addobj(GObject *obj)
  {   
     GObject *pom;

     pom = head;
     if (head == NULL)
       {
	  head = malloc(sizeof(GObject));
	  pom = head;
       }
     else
       {
	  while(pom->next != NULL)
	     pom = pom->next;
	  pom->next = malloc(sizeof(GObject));
	  pom = pom->next;
       }
     
     memcpy(pom, obj, sizeof(GObject));

     pom->next = NULL;

     return pom;
  }

void obj_save(GObject *obj, FILE *file)
  {
     fwrite(obj, sizeof(GObject), 1, file);
  }

void obj_saveall(FILE *file)
  {
     GObject *pom;

     pom = head;
     if(head != NULL)
       {
	  obj_save(pom, file);

	  while(pom->next != NULL)
	    {
	       pom = pom->next;
	       obj_save(pom, file);
	    }
       }
  }

GObject *obj_restore(FILE *file)
  {
     GObject *obj;
     int txt_len;
     
     obj = malloc(sizeof(GObject));

     fread(obj, sizeof(GObject), 1, file);
     obj->next = NULL;

/*     printf("type=%d x1=%d y1=%d x2=%d y2=%d text:%s\n",
	     obj->type, obj->x1, obj->y1, obj->x2, obj->y2, obj->text);
*/
     return obj;
  }

void obj_restoreall(FILE *file)
  {
     GObject *pom = head;

     if(pom != NULL)
       {
	  printf("Can't restore - object list not empty\n");
	  return;
       }

     while(!feof(file))
       {
	  if(head == NULL)
	    {
	       printf("Restoring first\n");
	       head = obj_restore(file);
	       printf("First restored\n");
	       pom = head;
	    }
	  else
	    {
	       printf("Restoring next\n");
	       pom->next = obj_restore(file);
	       pom = pom->next;
	    }
       }
	       
  }

void obj_draw(GObject *obj)
  {
     switch(obj->type)
       {
	  case LINE:
	  draw_line(obj->x1, obj->y1, obj->x2, obj->y2, 
		    obj->color, obj->width);
	  break;

	  case RECTANGLE:
	  draw_rectangle(obj->x1, obj->y1, obj->x2, obj->y2, 
			 obj->color, obj->width, 0);
	  break;

	  case FILLRECTANGLE:
	  draw_fillrectangle(obj->x1, obj->y1, obj->x2, obj->y2, 
			 obj->color, obj->width, 0);
	  break;

	  case ELIPSE:
	  draw_elipse(obj->x1, obj->y1, obj->x2, obj->y2, 
		      obj->color, obj->width, 0);
	  break;

	  case FILLELIPSE:
	  draw_fillelipse(obj->x1, obj->y1, obj->x2, obj->y2, 
		      obj->color, obj->width, 0);
	  break;

	  case GUMKA:
	  draw_gumka(obj->x1, obj->y1, obj->x2, obj->y2, 0);
	  break;

	  case TEXT:
	  draw_text(obj->x1, obj->y1, obj->text, obj->color);
	  break;
       }
  }

void obj_drawall()
  {
     GObject *pom;

     pom = head;
     if(head != NULL)
       {
	  obj_draw(pom);
	  while(pom->next != NULL)
	    {
	       pom = pom->next;
	       obj_draw(pom);
	    }
       }
  }

void obj_removeall()
  {
     GObject *pom;

     while(head != NULL)
       {
	  pom = head;
	  if(pom->next == NULL)
	    {	  
	       free(pom);
	       head = NULL;
	    }
	  else
	    {
	       while(pom->next->next != NULL)
		  pom = pom->next;
	       free(pom->next);
	       pom->next = NULL;
	    }
       }
  }

void obj_send(GObject *obj)
  {
     sendDVEobject(obj);
  }

void obj_sendall()
  {
     GObject *pom;

     pom = head;
     if(head != NULL)
       {
	  obj_send(pom);
	  while(pom->next != NULL)
	    {
	       pom = pom->next;
	       obj_send(pom);
	    }
       }
  }
