/******************************************************************
 *
 * Name:	Plugin_procs.c
 * 
 * Description:
 * 
 * Author:	Tomasz Stachowiak
 *
 * Date:	23/07/96
 *
 * Change Log:
 *
 ********************************************************************/

#include <stdio.h>
#include <sys/types.h>


#include <Xm/Xm.h>

#include "../lib/common.h"

#include "TSBoardPluginMotif.h"
#include "BoardPluginProtocol.h"

int current_state;
extern XtAppContext app;

extern ncsapp;

/**********************************************************************
 *
 * Functions kept for OpenDVE_procs.c compatibility
 *
 *********************************************************************/
void QueryPluginStatus()
{
  char msh[10];
  printf("Query plugin status\n");
  ncsAppSendData(ncsapp, 0, QUERY, msh, 10);
}

/********************************************************************
 *
 * Messages sending
 *
 *******************************************************************/
void sendDVEobject(boardPluginMessageStructure *obj)
  {
   boardPluginMessageStructure *msg;

   msg = malloc(sizeof(boardPluginMessageStructure));
   if (!msg)
   {
     printf("Message allocation error\n");
     return;
   }

   memcpy(msg, obj, sizeof(boardPluginMessageStructure));

   if(ncsAppSendData(ncsapp, -1, OBJECT, msg, 
		     sizeof(boardPluginMessageStructure)) < 0)
		printf("Sending failure\n");

   return;
  }


void
SendClear()
{
   boardPluginMessageStructure *msg;

   msg = malloc(sizeof(boardPluginMessageStructure));

   if (!msg)
   {
     printf("Message allocation error\n");
     return;
   }
 

   if(ncsAppSendData(ncsapp, -1, CLEAR, msg, 
		     sizeof(boardPluginMessageStructure)) < 0)
		printf("Sending failure\n");

   return;
}


/************************************************************************
 *
 * Conference mangement functions
 *
 ***********************************************************************/
/*
void 
MemberLeft()
{
   char str[100];

   sprintf(str, "User Left the Conference - %s@%s (%s)\n",
                    member.userName, member.hostName,
                    inet_ntoa(*(struct in_addr*)&((member.addr.v3))));
   XtWarning(str);
}

void 
MemberAdded(DveConfParticipant member)
{
   fprintf(stderr, "User Added to Conference - %s@%s (%s)\n",
                    member.userName, member.hostName,
                    inet_ntoa(*(struct in_addr*)&((member.addr.v3))));
}
*/

/**************************************************************************
 *
 * Function processing incoming messages
 *
 *************************************************************************/
void 
ProcessPluginMessage(int messageType, void *data) 
{
   boardPluginMessageStructure message;
   memcpy(&message, data, sizeof(boardPluginMessageStructure));
   

   switch (messageType){
      case OBJECT:
	 obj_addobj(&message);
	 obj_draw(&message);
	 break;
      case CLEAR:
	 Clear();
	 obj_removeall();
	 break;
      case QUERY:
	 obj_sendall();
	 break;
   }
}


/*********************************************************************
 *
 * Plugin management functions
 *
 ********************************************************************/
void 
ShowPlugin(void)
{
   fprintf(stderr, "ShowPlugin\n");
}

void 
HidePlugin(void)
{
   fprintf(stderr, "HidePlugin\n");
}

void 
CleanupPlugin(void)
{
}


/************************** END Plugin_procs.c **************************/








