/*
 *
 * Name:        Plugin_procs.c
 *
 * Description: conference management functionality for OpenDVE
 *		plugin for Netscape
 *              
 * Author:	Janusz Bulawa, NPAC
 *
 * Date:	July, 1996
 *
 */

#include <stdio.h>
#include <string.h>

#include <dve/Xm/recipientList.h>
#include <dve/pluginManagement.h>
#include <dve/confMgr.h>
#include "sessionData.h"

#define	JB_CONF_MANAGER_PORT	1

DveMotifRecipientList confList=NULL;
DvePartList partList;

DveSession dveSession=NULL;

void start_conference(void);
void finish(void);
void started(DveSession dveSession, DveEvent* event);
void HidePlugin();
void ShowPlugin();
DveConfMgrInvitationCallback invited(DveSession dveSession,
				     DveConfMgrInvitedArg* arg);

static ConfdStateTag confdState=confdStateTagInvalid;

/* 
 * Callback invoked when a user selects Exit from the File menu pulldown.
 */

void exit_conference(void)
{
  dveConfMgrLeaveConference(dveSession);
  QuitPlugin(dveSession);
}

DveConfMgrInvitationCallback invited(DveSession dveSession,
				     DveConfMgrInvitedArg* arg)
{
  int res;
  printf("RECEIVED INVITATION! from: %s at %s\n", (arg->parts[arg->initiatorIndex]).userName, (arg->parts[arg->initiatorIndex]).hostName);
  dveConfMgrAcceptInvitation(dveSession);
}

void start_conference(void)
{

  char *ptr;
  
  ptr = readConfDataFromStream(information, &numMem, &startFlag);
  mbrs = dveMalloc(n*sizeof(DveConfMgrUserAddr));
  mtemp = mbrs;
  printf("members (%d) location: %d\n", numMem, (int)mbrs);
  if (startFlag) SetMessage("Conference will be launched...")
  {
    for (i=0;i<numMem;i++)
      {
 /*     printf("Dane: %s\n", ptr);*/
        mtemp->userName = (char*)malloc(32);
        mtemp->hostName = (char*)malloc(64);
        parseIPaddress(ptr, mtemp->userName, mtemp->hostName);
        mtemp->addrs=NULL;
        printf("Member:%d Name: %s    Host: %s\n", i+1,
	       mtemp->userName, mtemp->hostName);
        mtemp+=sizeof(DveConfMgrUserAddr);
        ptr += strlen(ptr)+1;
      }
  }
  else /* Not startFlag */
     SetMessage("Will you accept invitation?");

  free(ptr);
  
  fflush(stdout);
  return;
}

void started(DveSession dveSession, DveEvent* event)
{
  int ilosc, i;
  ConfdStateTag stan;

  ilosc=event->arg.starting.numMembers;
  stan=event->arg.starting.state;
  fprintf(stdout, "I am invited! %d %d\n", ilosc, (int)stan);
  for (i=0;i<ilosc;i++)
    fprintf(stdout, "%s@%s\n", event->arg.starting.members[i].part.userName, event->arg.starting.members[i].part.hostName);
  fflush(stdout);
}


QuitPlugin(DveSession dveSession)
{
 
#ifdef XT
   dveUnregisterWithXt(dveSession);
#endif
 
#ifdef XVIEW
   dveUnregisterWithXView(dveSession);
#endif

   dveCloseSession(dveSession);
 
   exit(0);
}

/*
 * QuitPlugin if requested.
 */
static void
PluginControlMsg(DveSession dveSession, DveUserHandle sender,
                 DveDataPacket* packet)
{

printf("Nadeszly dane!\n");
  switch ((DvePluginManagementMsgTag)packet->tag)
   {
      case dvePluginManagementMsgTagQuit:
         QuitPlugin(dveSession);
         break;
      case dvePluginManagementMsgTagShow:
         ShowPlugin();
         break;
      case dvePluginManagementMsgTagHide:
         HidePlugin();
         break;
   }
}

void
HidePlugin()
{
   XtPopdown(MyShell);
}
 
void
ShowPlugin()
{
   XtPopup(MyShell, XtGrabNone);
}
 
void
introduceYourself()
{
   /*
    * Start up OpenDVE.
    */
   if (!(dveSession=dveOpenSession(JB_CONF_MANAGER_PORT)))
   {
      fprintf(stderr, "Initialization of OpenDVE Failed...exiting.\n\7");
      switch (dveError)
	{
	case dveErrOutOfMemory:
	  fprintf(stderr, "Error Condition: [Low memory.]\n");
	  break;
	  
	case dveErrNotFound:
	  fprintf(stderr, 
		  "Error Condition: [Conference Engine not found.]\n");
	  break;
	  
	case dveErrConnRefused:
	  fprintf(stderr, 
		  "Error Condition: [Engine refused connection.]\n");
	  break;
	default:
	  fprintf(stderr, "Unknown Error Condition.\n");
	  break;
	}
       exit(0);
   }

   dveSetUserCallback(dveSession,JB_CONF_MANAGER_PORT, PluginControlMsg);

   dveSetEventCallback(dveSession,dveEventTagStarting,started);
   dveConfMgrSetInvitationCallback(dveSession, invited);
     
   /*
    * Register this event processing with the Xt toolkit.  Without this
    * call OpenDVE events will not be received.
    */
   if (dveRegisterWithXt(dveSession,UxAppContext)<0)
   {
      fprintf(stderr, "Unable to register with Xt loop.");
      dveCloseSession(dveSession);
      exit(0);
   }

   dveReportPresence(dveSession);
   dveGetLocalMember(dveSession, &me);

}









