#include "launch.c"

static void manage(void);
static void invite(void);
static void acc(void);
static void reject(void);
static void leave(void);
static void finish(void);
static void members(void);
void SetMessage(char *msg);
void start_conference(void);

void
main()
{
  
  start_conference();
  printf("Skonczone!\n");
  
}

static void
invite(void)
{
  fprintf(stdout,"invited\n");
  fflush(stdout);
}

static void
acc(void)
{
  fprintf(stdout,"accepted\n");
  fflush(stdout);
}

static void
reject(void)
{
  fprintf(stdout,"rejected\n");
  fflush(stdout);
}

static void
leave(void)
{
  fprintf(stdout,"left\n");
  fflush(stdout);
}

static void
members(void)
{
  fprintf(stdout,"members\n");
  fflush(stdout);
}

static void
finish(void)
{
  fprintf(stdout,"EXIT\n");
  fflush(stdout);
}

void SetMessage(char* msg)
{
  fprintf(stdout, msg);
  fflush(stdout);
}


/***************************************************************************

  Definitions of OpenDVE-specific functions

***************************************************************************/  

int initLocalOpenDVE()
{
  int err;
  
  if ((err=check_process("ISregistrar", ""))<0)
  {
    failure("ISregistrar problem\n");
    return err;
  }
  sleep(1);
  if ((err=check_process("ISconferenceEngine", ""))<0)
  {
    failure("ISconferenceEngine problem\n");
    return err;
  }
  
  return 0;
}


void exit_conference(void)
{
  dveConfMgrLeaveConference(session);
  QuitPlugin(session);
}

DveConfMgrInvitationCallback invited(DveSession dveSession,
				     DveConfMgrInvitedArg* arg)
{
  int res;
  printf("RECEIVED INVITATION! from: %s at %s\n", (arg->parts[arg->initiatorIndex]).userName, (arg->parts[arg->initiatorIndex]).hostName);
  dveConfMgrAcceptInvitation(dveSession);
}

void start_conference(void)
{

  char *ptr;
  int i, err;

  information="#1#\n#5#\n#bulawa@sandman.npac.syr.edu#\n#bulawa@marilyn.npac.syr.edu#\n#jedrzejek@sulafat.npac.syr.edu#\n#toma@deneb.npac.syr.edu#\n#marek@trurl.npac.syr.edu#";

  for(i=0;i<strlen(information);i++) printf("%c", information[i]);
  ptr = readConfDataFromStream(information, &numMem, &startFlag);
  mbrs = dveMalloc(numMem*sizeof(DveConfMgrUserAddr));
  mtemp = mbrs;
  printf("members (%d) location: %d\n", numMem, (int)mbrs);
  for(i=0;i<strlen(information);i++) printf("%c", information[i]);
 
  SetMessage("Initializing Conference Engine...");
/*  if ((err=initLocalOpenDVE())<0)
    {
      SetMessage("Can not initialize OpenDVE... Aborted...");
      return;
    }
*/
  if (startFlag) 
  {
    SetMessage("Conference will be launched...");
    for (i=0;i<numMem;i++)
      {
        if ((mtemp->userName = (char*)malloc(128))==NULL)
	  printf("Can not allocate memory!!!!\n");;
        if ((mtemp->hostName = (char*)malloc(128))==NULL)
	  printf("Can not allocate memory!!!!\n");;
       
        parseIPaddress(ptr, mtemp->userName, mtemp->hostName);
	printf("User: %s Host: %s\n", mtemp->userName, mtemp->hostName);
        mtemp->addrs=NULL;
        mtemp+=sizeof(DveConfMgrUserAddr);
        ptr += strlen(ptr)+1;
      }
    SetMessage("Conference kick off...");
    fflush(stdout);
    localURL="http://koum:1972/jabu/default.dve";
    if ((err=launchRemote(mbrs, numMem))<0)
    {
      SetMessage("Conference kick off failed. Aborting...");
    }
       
/*    if ((err=introduceYourself(&session))<0)
    {
        SetMessage("Can not connect to Conference Engine... Aborted...");
        return;  
    }   
    SetMessage("Connected to Conference Engine...");*/
    printf("Inviting to the teleconference:\n");
    mtemp=mbrs; 
    for(i=0;i<numMem;i++)
    {
      printf("%s at %s\n", mtemp->userName, mtemp->hostName);
      mtemp+=sizeof(DveConfMgrUserAddr);
    }

    /*err = dveConfMgrInitiateConference(session, mbrs, numMem);*/
  }
  else /* Not startFlag */
  {
    if ((err=introduceYourself(&session))<0)
    {
        SetMessage("Can not connect to Conference Engine... Aborted...");
        return;  
    }  
    SetMessage("Connected to Conference Engine...");
    strcat(ptr, " INVITES you to teleconference!!! Will you accept?");
    SetMessage(ptr);
  }
   
  free(ptr);
  fflush(stdout);
  
/* Zwalnia pamiec */

  printf("Zwolnienie pamieci...\n");
  mtemp=mbrs;
    for(i=0;i<numMem;i++)
    {
      printf("%s at %s\n", mtemp->userName, mtemp->hostName);
      free(mtemp->userName);
      free(mtemp->hostName);
      mtemp+=sizeof(DveConfMgrUserAddr);
    }
  
  return;
}

void started(DveSession dveSession, DveEvent* event)
{
  int ilosc, i;
  ConfdStateTag stan;

  ilosc=event->arg.starting.numMembers;
  stan=event->arg.starting.state;
  fprintf(stdout, "I am invited! %d %d\n", ilosc, (int)stan);
  for (i=0;i<ilosc;i++)
    fprintf(stdout, "%s@%s\n", event->arg.starting.members[i].part.userName, event->arg.starting.members[i].part.hostName);
  fflush(stdout);
}


QuitPlugin(DveSession dveSession)
{
 
   dveUnregisterWithXt(dveSession);
   dveCloseSession(dveSession);
   exit(0);
}

/*
 * QuitPlugin if requested.
 */
static void
PluginControlMsg(DveSession dveSession, DveUserHandle sender,
                 DveDataPacket* packet)
{

printf("Nadeszly dane!\n");
  switch ((DvePluginManagementMsgTag)packet->tag)
   {
      case dvePluginManagementMsgTagQuit:
         QuitPlugin(dveSession);
         break;
      case dvePluginManagementMsgTagShow:
         ShowPlugin();
         break;
      case dvePluginManagementMsgTagHide:
         HidePlugin();
         break;
   }
}

void
HidePlugin()
{
/*   XtPopdown(MyShell);*/
}
 
void
ShowPlugin()
{
/*   XtPopup(MyShell, XtGrabNone);*/
}
 
int
introduceYourself(DveSession *session)
{
   /*
    * Start up OpenDVE.
    */
   if (!((*session)=dveOpenSession(JB_CONF_MANAGER_PORT)))
   {
      fprintf(stderr, "Initialization of OpenDVE Failed...exiting.\n\7");
      switch (dveError)
	{
	case dveErrOutOfMemory:
	  fprintf(stderr, "Error Condition: [Low memory.]\n");
	  break;
	  
	case dveErrNotFound:
	  fprintf(stderr, 
		  "Error Condition: [Conference Engine not found.]\n");
	  break;
	  
	case dveErrConnRefused:
	  fprintf(stderr, 
		  "Error Condition: [Engine refused connection.]\n");
	  break;
	default:
	  fprintf(stderr, "Unknown Error Condition.\n");
	  break;
	}
       return -1;
   }

   dveSetUserCallback(*session,JB_CONF_MANAGER_PORT, PluginControlMsg);

   dveSetEventCallback(*session,dveEventTagStarting,started);
   dveConfMgrSetInvitationCallback(*session, invited);
     
   /*
    * Register this event processing with the Xt toolkit.  Without this
    * call OpenDVE events will not be received.
    */
/*   if (dveRegisterWithXt(*session,AppContext)<0)
   {
      fprintf(stderr, "Unable to register with Xt loop.");
      dveCloseSession(*session);
      return -1;
   }
*/
   dveReportPresence(*session); 
   
   return 0;
}
