#include "launch.c"

#define DAEMON_MSG_LENGTH 128

void
main(void)
{
  int newconn, srv, err, len, i;
  struct sockaddr client;
  char *buffer;
  const char *options;

  /* open socket and listen to it */
  srv = setupSocket(DAEMON_PORT);
  if (srv<0) 
  {
    printf("Can not open socket! Exiting...\n");
    exit(0);
  }
  
  listen(srv, 5);
  len = sizeof(struct sockaddr);
  newconn=accept(srv, &client, &len);
    if (newconn<0) perror("Accept:\n");
  
  while(1) 	/* outer loop - daemon running in background */
  {
    fprintf(stderr, "Waiting for request...");
    fflush(stderr);
    while (newconn<=0)   /* inner loop - daemon accepts remote request */
    {
      newconn=accept(srv, &client, &len);
    }
    fprintf(stderr, "Connected...\n");
    fflush(stderr);
  
    buffer=(char*)malloc(DAEMON_MSG_LENGTH);
    memset(buffer, 0, DAEMON_MSG_LENGTH);
    err=read(newconn, buffer, DAEMON_MSG_LENGTH);
    buffer[err]='\0';
    printf("Daemon received %d bytes: %s\n", strlen(buffer), buffer);  

    if ((err=check_process("ISregistrar", ""))<0)
      failure("ISregistrar problem\n");
    sleep(1);
    if ((err=check_process("ISconferenceEngine", ""))<0)
      failure("ISconferenceEngine problem\n");
    sleep(1);

/*    if ((err=check_process("netscape3", buffer))<0) 
      failure("netscape problem\n");
    if (err==1971) /* netscape already running */

    {  
      char command[256];
      int err;
      
      command[0]='\0';
      strcat(command, "netscape3");
      strcat(command, " ");
      strcat(command, buffer);
      strcat(command, " &");
      
      err = system(command);
      if (err == -1)
      {
        failure( "system command failure in launcher");
      }

    }
    sleep(1);

    close(newconn);
    newconn=-1;
    free(buffer);
    
  } /* outer loop */ 
   
  close(srv);  
}






