/****************************************************************
 *
 * launch.c
 *
 ****************************************************************/
#include <stdio.h>
#include <netdb.h> 
#include <sys/types.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <sys/socket.h>
#include <sys/time.h>

void failure(char *msg);

void parseIPaddress(char *IP, char *name, char *host)
{
  char *ptr, *pos;
  int len, i;

  ptr = IP;
  pos = strchr(ptr, 64); /* code of @ */
  len = (int)pos - (int)ptr;
  memcpy(name, ptr, len);
  name[len]='\0';
  ptr += len+1;
  memcpy(host, ptr, strlen(IP)-len-1);
  host[strlen(IP)-len-1]='\0';
/*  printf("parseIP: name: %s host: %s|\n", name, host);*/
} /* parseIPaddress() */


int
findproc(char *proc)
{
  int err, pid, i;
  FILE *fp;
  char command[256];
  char name[9];

  for(i=0;i<8;i++)
    name[i]=proc[i];
  name[8]='\0';
  strcpy(command, "ps -e | grep ");
  strcat(command, name);
  strcat(command, " > .result");

  err = system(command);
  if (err == -1)
  {
    failure("launcher error");
    return err;
  }

  pid=0;
  fp = fopen(".result", "r");
  if (!fp)
  {
    failure("launcher: file open error");
    return -1;
  }
  fscanf(fp, "%d", &pid);
  fclose(fp);
  system("rm .result");
/*  printf("%s pid = %d\n", proc, pid);*/

  return pid;
} /* findproc() */

void failure(char *msg)
{
  fprintf(stderr, msg);
} /* failure() */

int
check_process(char *name, const char *opt)
{
  int pid;
  int err;
  char command[256];
  struct timeval start, stop;
  int diff = 0;

  command[0]='\0';
  strcat(command, name);
  /*  strcat(command, " ");
  strcat(command, opt);*/
  strcat(command, " &");

  pid = findproc(opt);
  if (pid<0) return -1; /* error */
  if (!pid) {

    gettimeofday(&start);
    err = system(command);
    if (err == -1)
    {
      failure( "system command failure in launcher");
      return err;
    }

    while(diff < 3)
      {
	gettimeofday(&stop);
	diff = stop.tv_sec - start.tv_sec;
      }

    fprintf(stdout, "Launching %s\n", command);
    fflush(stdout);
    fflush(stderr);

  }
  else
  {
/*    fprintf(stdout, "%s running already.\n", name);*/
    err=1971;
  }

  return err;
} /* check_process() */


char* changeURL(char *msg)
{
  char *pos, *newpos, *url;
  int k=0, len, needed;

  pos=msg;
/*  printf("Init pos: %d msg: %d %s\n", (int)pos, (int)msg, msg);*/

  while ((pos=strchr(pos, 47))!=NULL)
  {
    k++;
/*    printf("Pos: %d\n", (int)pos);*/
    newpos=pos;
    pos+=1;
    if (k>10) break;
  }
/*  printf("Last position: %d\n", (int)newpos);*/
  newpos++;
  len=(int)newpos-(int)msg;
  needed=len+strlen("default.dve");
/*  printf("Len: %d needed: %d\n", len, needed);*/
  url = (char*)malloc(needed);
  memcpy(url, msg, len);
  url[len]='\0';
/*  printf("First url: %s\n", url);*/
  strcat(url, "default.dve");
/*  printf("Second url: %s\n", url);*/
  return url;
}







