/*********************************************************************
 *
 * File:         daemon.h
 *
 * Description:  Header of conference engine daemon
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         10-14-96
 *
 *********************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>

#include <netdb.h>
#include <unistd.h>

/* Daemon data */
typedef struct _daemon_data
{
  int socket;
  struct sockaddr_in addr;
} DaemonData;

/* Raw message structure, used to determine the message is local */ 
typedef struct _raw_msg
{
  char local;
  char data[1];
} RawMessage;


void messageHandle(char *msg, int len, struct sockaddr_in *addr);
void handleLocalMessage(char *msg, int len);
void handleRemoteMessage(char *msg, int len);

void initDaemon();
void runDaemon();
