/*********************************************************************
 *
 * File:         session_manage.h
 *
 * Description:  Header of session management module for conference engine
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         10-15-96
 *
 *********************************************************************/

#include <stdio.h>
#include <stdlib.h>

typedef enum _session_status
{
  statusNone,
  statusInit,
  statusCreated,
  statusNonActive,
  statusActive
} SessionStatus;

typedef struct _session
{
  SessionStatus status;

  int memberActive[MAX_MEMBERS];
  struct sockaddr_in memberAddr[MAX_MEMBERS];
  Participant member[MAX_MEMBERS];
  int lastMember;
  int numMembers;
  int localMember;

  int appActive[MAX_APPS];
  int appPort[MAX_APPS];
  struct sockaddr_in appAddr[MAX_APPS];
  int lastApp;
  int numApps;
} Session;


int newMember(Participant *member);
int getManagerAddr(struct sockaddr_in *addr);
int getUserData(int userNo, struct sockaddr_in *addr, Participant *part);
int sessionInit();
int sessionCreate(Participant *initiator);
int sessionAddMember(Participant *newmember);
void sessionDeleteMember(Participant *member);
