#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define SERV_ADDR "128.230.117.32"

int writen(int socket, char *buf, int len)
{
  int nleft, nwritten;

  nleft = len;
  while(nleft > 0)
    {
      nwritten = write(socket, buf, nleft);
      if(nwritten <= 0)
	return nwritten;

      nleft -= nwritten;
      buf += nwritten;
    }
  return len - nleft;
}

const char *messages[] = {"Hi!", "It's me!", "How you doing?"} ;

main()
{
  struct sockaddr_in serv_addr, local_addr;
  int sock;
  int i, size;

  bzero(&serv_addr, sizeof(serv_addr));
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr = inet_addr(SERV_ADDR);
  serv_addr.sin_port = htons(5000);

  bzero(&local_addr, sizeof(local_addr));
  local_addr.sin_family = AF_INET;
  local_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  local_addr.sin_port = htons(4999);

  if((sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    fprintf(stderr, "Socket open error\n");

  if(bind(sock, &local_addr, sizeof(struct sockaddr_in)) < 0)
    fprintf(stderr, "Can't bind local socket\n");
  
  for(i=0; i<3; i++)
    {
      size = strlen(messages[i]);
      sendto(sock, &size, sizeof(int), 0, &serv_addr, sizeof(serv_addr));
      sendto(sock, (char *)messages[i], size, 0, &serv_addr, sizeof(serv_addr));
      printf("Send: %s\n", messages[i]);
      sleep(1);
    }
    
  close(sock);
}

