/*
 *	Protocol Specification for VideoPlugin
 *
 * Name:        JBVideoPlugin
 *
 * Description: handles h.263 video data
 *
 * Author:      Janusz Bulawa & Tomasz Stachowiak, NPAC
 * Date:	july, 1996
 */

#include <sys/types.h>
#include <sys/time.h>

#define VIDEO_PLUGIN_PORT   34999   /* plugin-to-plugin communication */

#define MAX_FRAME_SIZE	    20000

#define STOP	0
#define	PLAY	1
#define PANEL   2

typedef enum {
   H263 = 0,
   H261,   
  videoTagInvalid,     /* Never used */
  videoTagPlay,    
  videoTagConfirm,    
  videoTagStop,
  videoTagExit,
  videoTagData,
  videoTagFrameDecoded
} VideoTag;

typedef struct videoPluginArg {
  int frate;	/* suggested frame rate */
  int format;   /* required picture format */
} VideoPluginArg;

typedef struct videoDataArg {
  int len;
  int seqNum;
  char* videodata;
} VideoDataArg;

typedef struct _videoPluginFrame
{
  struct timeval time;
  char data[1];
} VideoPluginFrame;
    
int framenum=0;

char* vdata;
int state;















