#include <stdio.h>
#include <sys/time.h>

#define mmin(a,b) (a<b?a:b)	    /* */
#define mmax(a,b) (a>b?a:b)
#define ABS(t) (((t)>>31) ? (~t+1) : (t))
#define ABS3(t) (~t+1)
#define sign(a) ((a) < 0 ? -1 : 1)  /* */
#define SIGN2(a) (a&0x8000? -1 : 1)

#define TIMES	3839616

void Quant(int *coeff, int *qcoeff, int QP, int Mode)
{
  int i;
  int level;
/* JABU */
  register int aux1;
  register int aux2;

  aux1=QP<<1;
  aux2=QP>>1;
 
  if (QP) {
    if (Mode>2) { /* Intra */
      qcoeff[0] = mmax(1,mmin(254,coeff[0]>>3));

      for (i = 1; i < 64; i++) {
        level = (ABS(coeff[i])) / (aux1);
        qcoeff[i] =  mmin(127,mmax(-127,sign(coeff[i]) * level));
      }
    }
    else { /* non Intra */
      for (i = 0; i < 64; i++) {
        level = (ABS(coeff[i])-aux2)  / (aux1);
        qcoeff[i] = mmin(127,mmax(-127,sign(coeff[i]) * level));
      }
    }
  }
  else {
    /* No quantizing.
       Used only for testing. Bitstream will not be decodable 
       whether clipping is performed or not */
    for (i = 0; i < 64; i++) {
      qcoeff[i] = coeff[i];
    }
  }
  return;
}

void
main()
{
  int i, runtime;
  int x, k;
  struct timeval start, stop;

  int        coeff[384];
  int        *coeff_ind;
  int                *qcoeff;
  int        *qcoeff_ind;

  if ((qcoeff=(int *)malloc(sizeof(int)*384)) == 0) {
    fprintf(stderr,"mb_encode(): Couldn't allocate qcoeff.\n");
    exit(-1);
  }

  coeff_ind = coeff;
  qcoeff_ind = qcoeff;
  
  gettimeofday(&start,(struct timezone *)NULL);
  
  for(i=0;i<100000;i++){
/*    printf("%d ",i);*/
    Quant(coeff_ind,qcoeff_ind,10,3);
  } 
  
/*  k=MMIN(-127, MMAX(i, SIGN1(i)*10));*/

  gettimeofday(&stop,(struct timezone *)NULL);
  runtime = 100*(stop.tv_sec-start.tv_sec)
    + (stop.tv_usec-start.tv_usec)/10000;
  if (runtime!=0)
    printf("\ntotal : %d.%02d seconds (%d)\n",
           runtime/100, runtime%100, runtime);

    exit(0);
  
  gettimeofday(&start,(struct timezone *)NULL);
  
  for(i=0;i<TIMES+1;i++)
    k=i;

  gettimeofday(&stop,(struct timezone *)NULL);
  runtime = 100*(stop.tv_sec-start.tv_sec)
    + (stop.tv_usec-start.tv_usec)/10000;
  if (runtime!=0)
    printf("\nx<<1 : %d.%02d seconds (%d)\n",
           runtime/100, runtime%100, runtime);
  
  gettimeofday(&start,(struct timezone *)NULL);
  
  for(i=0;i<TIMES+1;i++)
    k=i/2;

  gettimeofday(&stop,(struct timezone *)NULL);
  runtime = 100*(stop.tv_sec-start.tv_sec)
    + (stop.tv_usec-start.tv_usec)/10000;
  if (runtime!=0)
    printf("\nx*2 : %d.%02d seconds (%d)\n",
           runtime/100, runtime%100, runtime);

}
      
