/*********************************************************************
 *
 * File:         sessions.c
 *
 * Description:  NPAC Conferencing System API functions for session 
 *               management 
 *
 * Author:       Tomasz Stachowiak, NPAC
 *
 * Date:         10-14-96
 *
 *********************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>

#include <netdb.h>
#include <unistd.h>

#include "common.h"

extern ManagerData managerData;

void nic()
{
}


/* The lowest level control packages sending procedure */
int sendControlPacket(struct sockaddr_in *addr, char *msg, int len)
{
  if(sendto(managerData.socket, msg, len, 
	 0, addr, sizeof(struct sockaddr_in)) < 0)
    return 0;  

  return 1;
}

int ncsEngineRequest(short tag, char *data, int len)
{
  Message *msg;
  int size;

  size = sizeof(Message) + len - 1;
  msg = malloc(size);
  if(msg == NULL)
    fprintf(stderr, "Manager: control message allocation error\n");
  msg->local = 1;
  msg->tag = tag;
  memcpy(msg->data, data, len);
  cuserid(msg->sender.user);
  gethostname(msg->sender.host, 50);

  if(sendControlPacket(&managerData.daemon_addr, (char *)msg, size) < 0)
    return 0; 

  return 1;
}

/* The lowest level data packages sending procedure */
int sendPacket(int socket, struct sockaddr_in *addr, char *msg, int len)
{
  if(sendto(socket, msg, len, 
	 0, addr, sizeof(struct sockaddr_in)) < 0)
    return 0;  

  return 1;
}
